stages:
  - build
  - upload
  - release

build-test-debug-stable:
  stage: build
  image: rust:latest
  script:
    - cargo build --verbose
    - cargo test --verbose

build-test-debug-nightly:
  stage: build
  image: rustlang/rust:nightly
  script:
    - cargo build --verbose
    - cargo test --verbose
  allow_failure: true

build-release:
  stage: build
  image: rust:latest
  script:
    - cargo build --package sccache --release
  artifacts:
    paths:
      - ./target/release/sccache

upload-release:
  before_script: []
  dependencies:
    - build-release
  needs:
    - build-release
  stage: upload
  image: curlimages/curl:latest
  rules:
    - if: $CI_COMMIT_TAG
  script: |
    set -x
    export PACKAGE_REGISTRY_URL="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/sccache/${CI_COMMIT_TAG}"
    curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file ./target/release/sccache "${PACKAGE_REGISTRY_URL}/sccache"

make-release:
  before_script: []
  dependencies:
    - build-release
  needs:
    - build-release
    - upload-release
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  rules:
    - if: $CI_COMMIT_TAG
  script: |
    set -x
    export PACKAGE_REGISTRY_URL="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/sccache/${CI_COMMIT_TAG}"
    release-cli create --name "Release $CI_COMMIT_TAG" --tag-name $CI_COMMIT_TAG \
        --assets-link "{\"name\":\"sccache\",\"url\":\"${PACKAGE_REGISTRY_URL}/sccache\"}"
